unit minedoutspieler;

{$mode objfpc}{$H+}

interface

uses Classes, SysUtils, minedoutbase;

type

  { TSpieler }

  TSpieler = class
    private
      FPosition : TPos;
      function getX : Integer;
      function getY : Integer;
      function getPosition : TPos;
      procedure MeldeBewegung(AltePos, NeuePos: TPos);

    public
      BewegungMelden : TBewegungEvent;
      constructor Create(APos: TPos);
      destructor Destroy; override;
      property X : Integer read getX;
      property Y : Integer read getY;
      property Position : TPos read getPosition;
      procedure GeheNachNorden;
      procedure GeheNachSueden;
      procedure GeheNachOsten;
      procedure GeheNachWesten;
   end;



implementation

{ TSpieler }

function TSpieler.getX: Integer;
begin
  Result := FPosition.X;
end;

function TSpieler.getY: Integer;
begin
  Result := FPosition.Y;
end;

function TSpieler.getPosition: TPos;
begin
  Result := FPosition;
end;

procedure TSpieler.MeldeBewegung(AltePos, NeuePos: TPos);
begin
  if Assigned(BewegungMelden) then
    BewegungMelden(AltePos, NeuePos);
end;

constructor TSpieler.Create(APos : TPos);
begin
  FPosition :=APos;

end;

destructor TSpieler.Destroy;
begin
  inherited Destroy;
end;

procedure TSpieler.GeheNachNorden;
var
  AltePos : TPos;
begin
  AltePos := FPosition;
  Inc(FPosition.Y);
  MeldeBewegung(AltePos, FPosition);
end;

procedure TSpieler.GeheNachSueden;
var
  AltePos : TPos;
begin
  AltePos := FPosition;
  Dec(FPosition.Y);
  MeldeBewegung(AltePos, FPosition);
end;

procedure TSpieler.GeheNachOsten;
Var
  AltePos: TPos;
begin
  AltePos := FPosition;
  Inc(FPosition.X);
  MeldeBewegung(AltePos, FPosition);
end;

procedure TSpieler.GeheNachWesten;
var
  AltePos : TPos;
begin
  AltePos := FPosition;
  Dec(FPosition.X);
  MeldeBewegung(AltePos, FPosition);
end;




end.

